* mail.prg
*
* The mail merge program illustrates DDE with Word.
* The scenario involves a database containing job
* applicants. Another database is used which has a
* binary memo field containing the contents of a 
* Word letter. There are applicant action letters for 
* rejections, interviews and job offers.
*


#DEFINE worddatafile	"MAILDATA.DBF"		 &&Print Merge Datafile
#DEFINE docpath			"D:\BOOK\DDE\MAIL\"  &&path of all docs
#DEFINE docpath2		"D:\BOOK\DDE\MAIL"  &&path of all docs
#DEFINE formfile		"FORM.DOC"			 &&letter template
#DEFINE cret			CHR(13)+CHR(10)
#DEFINE tab				CHR(9)
#DEFINE timeouterr		9
#DEFINE noclienterr		13

* Message Box Definitions
#define MB_OK		    	0
#define MB_YESNO	    	4
#define IS_YES  	    	6
#define MB_ICONQUESTION		32
#DEFINE MB_TITLE			"Microsoft FoxPro"
#DEFINE MB_KEEPLETTER		"Do you wish to update letters database with saved letter?";
							+cret+cret+"Letter: " 
#DEFINE MB_DELETELET		"Do you really wish to delete this letter from database?" 
#DEFINE MB_SAVELETTER		"The following letter is still open. Do you wish to "+;
							"save it to the database ('No' loses any changes)? ";
							+cret+cret+"Letter: " 

PRIVATE donebtn,letterbtn,getletter,prntprev
PRIVATE sysch,mchan
PRIVATE oldsafe,olddelete
PRIVATE letterarr,channelarr,isWord2

DIMENSION letterarr[1]

STORE .T. TO m.isWord2				&& using Word2 or Word6 
STORE 0 To m.prntprev				&& check-box memvar
STORE 1 TO m.donebtn,m.letterbtn 	&& screen button memvars
STORE -1 TO m.sysch,m.mchan			&& DDE channel memvars

m.olddelete=SET('DELETE')
m.oldsafe=SET('SAFE')
SET SAFETY OFF
SET DELETED ON

IF !USED('recruits')
  USE recruits IN 0
ENDIF
IF !USED('letters')
  USE letters IN 0
ENDIF

* 2D Array for handling all open documents
* since each open Word letter can have its
* own DDE channel. 1st element is file name.
* 2nd element is DDE channel. If not an open
* channel, then it is set to -1.
SELECT UPPER(lettername),-1 FROM letters;
  WHERE !EMPTY(letterid);
  INTO ARRAY channelarr

* Create array for screen popup
DO makelarray
STORE letterarr[1] TO m.getletter

SELECT letters

DO mail.spr		&&call screen

* Cleanup
SET SAFETY &oldsafe
SET DELETED &olddelete
USE IN letters
USE IN recruits


*** PROCEDURES ***

FUNCTION MYALERT
* Dislays an alert dialog box with question.
	PARAMETER mnote
	PRIVATE waitvar
	IF setlib(SYS(2004)+'foxtools.fll')
	  RETURN msgbox(mnote,MB_TITLE,MB_YESNO+MB_ICONQUESTION)=IS_YES  
	ELSE
	  WAIT WINDOW P1+'(Y/N)' TO waitvar
	  RETURN waitvar$'Yy'
	ENDIF
RETURN

FUNCTION setlib
* Checks to see if library available (i.e., FOXTOOLS)
	PARAMETER libname
	IF !UPPER(m.libname) $ SET('LIBRARY')
	  PRIVATE olderr
	  olderr=ON('ERROR')
	  ON ERROR *  	&&traps for cancel button
	  SET LIBRARY TO LOCFILE(m.libname,'FLL','Locate file '+UPPER(m.libname)) ADDITIVE
	  ON ERROR &olderr
	  IF !UPPER(m.libname) $ SET('LIBRARY')
	    *wrong library entered or cancel button pressed
	    WAIT WINDOW 'Operation cancelled or incorrect library selected.'
	    RETURN .F.
	  ENDIF
	ENDIF
RETURN .T.

PROCEDURE letterpopval
* VALID statement of screen popup
    LOCATE FOR UPPER(letters.lettername)=ALLT(m.getletter)
	SHOW GETS
RETURN

PROCEDURE donebtnval
* Donebtn VALID statement
	DO CASE
	CASE m.donebtn=1	&&mail merge button
	  DO mmerge
	CASE m.donebtn=2	&&done button
	  * Check if any open DDE channels to letters
	  IF chkchannels()
	    CLEAR READ
	  ENDIF
	ENDCASE
RETURN

PROCEDURE makelarray
* Create array for popup
	SELECT UPPER(lettername) FROM letters;
	  WHERE !EMPTY(letterid);
	  INTO ARRAY letterarr
RETURN

PROCEDURE chkchannels
* At close of screen, checks to see if any
* open channels to Word letters. If so, it
* closes them, prompts to save letter to
* letters database, and then deletes file.
	PRIVATE i
	* Check if dialog open in Word OR Word quit
	IF m.sysch#-1
	  =DDERequest(m.sysch,'topics')
	  IF DDELastError()#noclienterr;
		  AND !chkcommand()
	    RETURN .F.
	  ENDIF
	ENDIF
	
	* Check each document in database and
	* if it is open in Word. Then it closes
	* document and saves to database if prompted.
	* Must reset the file so that Print Merge 
	* Datafile is not attached.
	FOR i=1 TO ALEN(channelarr,1)
	  IF channelarr[i,2]#-1
	    = DDETerminate[channelarr[i,2]]
	    = ActWindow(channelarr[i,1])
	    = DDEExecute(m.sysch,"[FilePrintMergeReset]")
		IF MYALERT(MB_SAVELETTER+channelarr[i,1])
	      = DDEExecute(m.sysch,'[FileClose 1]')
		  LOCATE FOR UPPER(letters.lettername)=ALLT(channelarr[i,1])
		  APPEND MEMO wordletter FROM (lettername) OVERWRITE
		ELSE
	      = DDEExecute(m.sysch,'[FileClose 1]')
		ENDIF
	    DELETE FILE (docpath+channelarr[i,1])
	  ELSE
	    IF FILE(docpath+channelarr[i,1])
	        DELETE FILE (docpath+channelarr[i,1])
	    ENDIF
	  ENDIF
	ENDFOR
	
	* Now close DDE system channel
	IF m.sysch#-1
	    =DDETerminate(m.sysch)
	ENDIF
RETURN

PROCEDURE letterbtnval
* VALID for letter edit buttons
	DO CASE
	CASE m.letterbtn=1	&& add
	  DO addletter
 	  DO makelarray		&&reset popup array
	  SHOW GETS
	CASE m.letterbtn=2	&& edit
	  DO editletter
	CASE m.letterbtn=3	&& delete
	  IF MYALERT(MB_DELETELET)
        LOCATE FOR UPPER(letters.lettername)=ALLT(m.getletter)
	    DELETE
	    DO makelarray
	    LOCATE
	    STORE letterarr[1] TO m.getletter
	    SHOW GETS
	  ENDIF
	ENDCASE
RETURN

FUNCTION startword
* Routine is called to check if Word is 
* running and/or DDE system channel is set.
* Also check if Word was closed by user
* while FoxPro screen open.
	
	* Terminate a prior channel if user quit Word
	* while still in screen.
	IF m.sysch#-1
	  =DDERequest(m.sysch,'topics')
	  IF DDELastError()=noclienterr
	    =DDETerminate(m.sysch)
	  	m.sysch=-1
	  ENDIF
	ENDIF
	IF m.sysch=-1
	  =DDESetOption("SAFETY",.F.)
	  m.sysch=DDEInitiate("Winword","System")
	  IF m.sysch=-1				&&failed
		WAIT WINDOW "Starting Word..." NOWAIT
	    RUN /N7 WINWORD
		m.sysch=DDEInitiate("Winword","System")
	  ENDIF
	  IF m.sysch=-1
	    WAIT WINDOW 'There is a problem starting up Word...'
	    RETURN .F.
	  ENDIF
	ENDIF
	* Check to see if Word is in Modal mode.
	IF !chkcommand()
	    RETURN .F.
	ENDIF
	* Check for Word 6
	m.isWord2 = ATC("WOOZLE",DDERequest(m.sysch,"FORMATS"))=0

RETURN .T.

FUNCTION chkcommand
* This is an extremely important funtion!!!
* WordBasic commands will display a dialog when they fail.
* This includes situations when modal dialogs or print 
* previews are open. If Word is in a modal mode, then this
* function fails and you can stop program control.

	* This next call will fail by timing out 
	* in 2 seconds if Word has a dialog open.
	=DDERequest(m.sysch,'topics')
	IF DDELastError()=timeouterr
	  WAIT WINDOW 'Could not execute task. Check Word for open dialog or other problem...'
	  RETURN .F.
	ENDIF
	* Must also reset print preview to off if it is on
	= DDEExecute(m.sysch,"[IF CountWindows()<>0 THEN IF FilePrintPreview()=-1 THEN FilePrintPreview 0]")
RETURN

PROCEDURE addletter
* Function performed when Add letter button pressed. 
	PRIVATE newbtn,filename,descript,hiletterid,tempchan
	STORE 1 TO m.newbtn
	STORE "" TO m.descript,m.filename
	DO newletr.spr	&&call screen
	IF m.newbtn=2	&&cancel button pressed
	  RETURN
	ENDIF
	m.filename=UPPER(ALLT(m.filename))+".DOC"
	IF ASCAN(channelarr,m.filename)#0
	  WAIT WINDOW 'File name is already used. Try another...'
	  RETURN
	ENDIF
	* Obtain next unique id for letter in letters database
	CALC MAX(letterid) to m.hiletterid
	IF !startword()
	  RETURN
	ENDIF
	* Add a new record for new letter
	INSERT INTO letters VALUES(CHR(ASC(m.hiletterid)+1),m.filename,m.descript,'')
	* Update arrays with new letter
	DIMENSION channelarr[ALEN(channelarr,1)+1,2]
	channelarr[ALEN(channelarr,1),1]=m.filename
	channelarr[ALEN(channelarr,1),2]=-1
	getletter=m.filename
	* Create new Word letter from form letter
	LOCATE FOR UPPER(letters.lettername)=formfile
	COPY MEMO letters.wordletter TO (docpath+letters.lettername)
	= DDEExecute(m.sysch,'[FileOpen "'+docpath+letters.lettername+'"]')
	tempchan=DDEInitiate('winword',ALLT(letters.lettername))
	* Saves form letter as new name given above
	= DDEExecute(m.tempchan,'[FileSaveAs "'+docpath+filename+'"]')
	= DDETerminate(m.tempchan)
	* Delete form letter
	DELETE FILE (docpath+letters.lettername)
	DO editletter	&& open letter in Word
RETURN

PROCEDURE editletter
* Function performed by Edit button
	PRIVATE mpos,tempchan
	LOCATE FOR UPPER(letters.lettername)=ALLT(m.getletter)
	IF !startword()
	  RETURN
	ENDIF
	m.mpos=ASCAN(channelarr,UPPER(ALLTRIM(letters.lettername)))
	* Check to see if a DDE channel exist with this letter
	IF channelarr[m.mpos+1]=-1
	  * Check if file open but no DDE channel
	  IF !ALLT(UPPER(letters.lettername))$DDERequest(m.sysch,"topics")
	    *Check if file exists, else copy from memo field
	    IF !FILE(docpath+letters.lettername)
	      COPY MEMO letters.wordletter TO (docpath+letters.lettername)
	    ENDIF
	    * Open document in Word
	    = DDEExecute(m.sysch,'[FileOpen "'+docpath+letters.lettername+'"]')
	  ENDIF
	  m.tempchan=DDEInitiate("WinWord",docpath+letters.lettername)
	  ***Important Call***
	  * Sets up a warm link between FoxPro and entire document.
	  * The SaveLetter procedure is invoked when user tries to close
	  * document. This insures that Letters database always gets
	  * updated.   
	  = DDEAdvise(m.tempchan,'\DOC','SaveLetter',1)	&& Notify link
	  channelarr[m.mpos+1]=m.tempchan
	  = DDEExecute(m.sysch, '[If DocMaximize() Then DocRestore]')
	ELSE	
	  * Channel already exists so simply activate window.
	  tempchan=channelarr[m.mpos+1]
	  =ActWindow(channelarr[m.mpos])
	ENDIF
	* Bring Word forward for user editing.
	= DDEExecute(m.sysch, '[If AppRestore() = 0 Then AppRestore]')
	= DDEExecute(m.sysch, '[AppActivate "Microsoft Word",1]')
	= DDEExecute(m.tempchan, '[DocMaximize]')
RETURN

PROCEDURE SaveLetter
* This routine is called from DDEAdvise call in EditLetter
* routine. It only does anything when user terminates 
* link such as by closing a document directly in Word.
	PARAMETERS channel, action, item, data, format, advise
	PRIVATE tempchan,mpos
	m.mpos=ASCAN(channelarr,channel)
	* Resets DDE channel to off status
	channelarr[m.mpos]=-1
	DO CASE
	CASE action = 'ADVISE'
	  *nothing here, maybe you want some indication
	CASE action = 'TERMINATE'
	  * Terminates the DDE channel with Word letter. Prompts
	  * user to update letters database. Finally deletes
	  * the letter file. 
	  = DDEExecute(m.sysch,'[AppActivate "Microsoft FoxPro",1]')
	  = DDETerminate(channel)
	  IF MYALERT(MB_KEEPLETTER+channelarr[m.mpos-1])
	    LOCATE FOR UPPER(letters.lettername)=ALLT(channelarr[m.mpos-1])
		APPEND MEMO letters.wordletter FROM (letters.lettername) OVERWRITE
	  ENDIF
	  DELETE FILE (docpath+letters.lettername)
	ENDCASE
RETURN

PROCEDURE mmerge
* Mail Merge routine. This routine opens a letter
* and performs a mail merge from a FoxPro DBF
* file. Letter cannot be already opened since user may
* be in the middle of editing and warm link can
* possibly intervene.
	PRIVATE tempchan
	DELETE FILE (docpath+worddatafile)
	SELECT recruits
	COPY TO (docpath+worddatafile) FOR recruits.letterid=letters.letterid
	SELECT letters
	IF _TALLY=0
	  WAIT WINDOW 'No records were found for selected record...'
	  RETURN
	ENDIF
    IF !startword()
      RETURN
    ENDIF
    LOCATE FOR UPPER(letters.lettername)=ALLT(m.getletter)  
    IF ALLT(m.getletter)$DDERequest(m.sysch,"topics")
      WAIT WINDOW 'You must close the document before performing a mail merge...'
      = ActWindow(m.getletter)
      RETURN
    ENDIF
    * Important. Need to set timeout high enough
    * so that FilePrintMergeToDoc command does not
    * timeout before it completes.
    =DDESetOption("TIMEOUT",100000)
	IF !FILE (docpath+letters.lettername)
      COPY MEMO letters.wordletter TO (docpath+letters.lettername)
    ENDIF
    = DDEExecute(m.sysch,'[FileOpen "'+docpath+letters.lettername+'"]')
    = DDEExecute(m.sysch,'[If DocMaximize() Then DocRestore]')
    m.tempchan=DDEINITIATE('winword',ALLT(m.getletter))

	IF m.isWord2
    	* Use this next routine for Word 2.0
    	DO WORD2
    ELSE
    	* Use this next routine for Word 6.0
    	DO WORD6
	ENDIF
	
	* Do some cleanup
   	 = DDEExecute(m.sysch,'[FileClose 2]')
	 DELETE FILE (docpath+letters.lettername)

	* If checkbox then Print Preview 
	IF m.prntprev=1
  		= DDEExecute(m.sysch,'[FilePrintPreview 1]')
	ENDIF

	* Reset timeout to default 2 seconds
    = DDESetOption("TIMEOUT",2000)
  	= DDEExecute(m.sysch, '[If AppRestore() = 0 Then AppRestore]')
RETURN

PROCEDURE word2
	= DDEExecute(m.sysch,'[FileOpenDataFile "'+docpath+worddatafile+'"]')
	= DDEExecute(m.sysch,'[FilePrintMergeToDoc]')
	= DDETerminate(m.tempchan)
	= ActWindow(m.getletter)
	= DDEExecute(m.sysch,'[FilePrintMergeReset]')
RETURN

PROCEDURE word6
	= DDEExecute(m.sysch,'[MailMergeMainDocumentType 0]')
	= DDEExecute(m.sysch,'[MailMergeOpenDataSource '+;
		' .Name = "'+docpath+worddatafile+'",'+;
		' .ConfirmConversions = 0, .LinkToSource = 1,'+;
		' .Connection = "DSN=FoxPro;DBQ='+docpath2+';FIL=FoxPro 2.5;",'+;
		' .SQLStatement = "SELECT * FROM MAILDATA"]')
	 = DDEExecute(m.sysch,'[MailMerge .CheckErrors = 1, .Destination = 0, .MergeRecords = 0, .From = "", .To = "", .Suppression = 0, .MailMerge, .MailSubject = "", .MailAsAttachment = 0, .MailAddress = ""]')
	 = DDETerminate(m.tempchan)
	 = ActWindow(m.getletter)
	 = DDEExecute(m.sysch,'[MailMergeReset]')
RETURN

FUNCTION ActWindow
* This function is used to activate a window in Word.
* The problem is that the window title can change as
* files are opened from other directories. This insures
* that the WordBasic Activate command does not fail.
	PARAMETER winname
	PRIVATE totaltopics,winnum,z
	winname=ALLT(winname)
	* Get number of topics to determine number of 
	* open windows.
	m.totaltopics=OCCURS(tab,DDERequest(m.sysch,'topics'))
	* These next two topics are not included in Window menu
	IF 'NORMAL.DOT'$DDERequest(m.sysch,'topics')
	  m.totaltopics=m.totaltopics-1
	ENDIF
	IF '.DBF'$DDERequest(m.sysch,'topics')
	  m.totaltopics=m.totaltopics-1
	ENDIF
	= DDEExecute(m.sysch,'[If DocMaximize() Then DocRestore]')
	* Go through all system topics to find right window.
	FOR z=1 TO m.totaltopics
	  winnum=ALLTRIM(STR(z))
	  = DDEExecute(m.sysch,'[wn$=WindowName$('+winnum+')]'+;
	   	 '[If INSTR(wn$,"'+winname+'") <> 0 Then Activate wn$]')
	ENDFOR
RETURN

